void SetSkillSource(char** Vals, void* TargetStruct, int Number, bool header)
{
	int i, j;
	static int ClassPosition[128];
	static int name, attr, valcount;

	if (header)
	{
		for (i = 0;i < Source.CharSourceCount;i++)
		{
			ClassPosition[i] = GetValNumber(Vals, Source.CharSource[i].Name.buffer, Number, false);
		}
		name = GetValNumber(Vals, "Name", Number);
		attr = GetValNumber(Vals, "Attr", Number);
		valcount = Number;
		return;
	}

	if (Number != valcount)
	{
		printf("Invalid Number of Arguments in SkillSource Database\n");
		quitprog();
	}

	((clsSkills*) TargetStruct)->Name = Vals[name];
	((clsSkills*) TargetStruct)->Attr = atoi(Vals[attr]);

	((clsSkills*) TargetStruct)->Prob = (int*) mallocl(Source.CharSourceCount * sizeof(int), "SetSkillSource-Prob");
	for (i = 0;i < Source.CharSourceCount;i++)
	{
		if (ClassPosition[i] == -1)
		{
			((clsSkills*) TargetStruct)->Prob[i] = 1;

			for (j = 0;j < i;j++)
			{
				if (((clsSkills*) TargetStruct)->Prob[j] == 0)
				{
					((clsSkills*) TargetStruct)->Prob[i] = 0;
					break;
				}
			}
		}
		else
		{
			((clsSkills*) TargetStruct)->Prob[i] = atoi(Vals[ClassPosition[i]]);
		}
	}
}

int GetSkillNumber(char* SkillName, int uncomplete = 0)
{
	int i;
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		if (Source.SkillSource[i].Name == SkillName)
		{
			return(i);
		}
		if (uncomplete == 1 && strstr(Source.SkillSource[i].Name, SkillName) != 0)
		{
			return(i);
		}
	}
	printf("Skill not found(%s)\n", SkillName);
	quitprog();
	return(0);
}

void SkillSourceExit()
{
	int i;
	for (i = 0;i < Source.SkillSourceCount;i++)
	{
		freel(Source.SkillSource[i].Prob);
	}
	delete[] Source.SkillSource;
}
