int run_init()
{
	LARGE_INTEGER init_start, init_end, init_bnfpassed;

	QueryPerformanceCounter(&init_start);
	
	printf("Initializing Data...");


	if (MustRebuild || TestScript)
	{
		if (!MustRebuild)
		{
			free(bnf::SymbolNames);
		}

		printf("Initializing Script Grammar\n");
		if (bnf::bnfinit())
		{
			printf("Error initialising Script Grammer\n");
			return(1);
		}
	}

	Source.lpSymbolStart = bnf::SymbolNames;

	if (RedirectSymbols())
	{
		return(1);
	}
	
#ifdef AllowTestScript
	if (TestScript)
	{
		char TestScriptOut[BufferLen] = "";

		bnf::SplitFile("TestScript.scr");
		DebugOutput = 1;
		RunScript(&cDumpChar, &eDumpEquip, TestScriptOut, bnf::pTree);

		printf("\n\nText:\n\n%s", TestScriptOut);

		getchar();
		bnf::bnfexit();
		return(-1);
	}
#endif

	if (MustRebuild)
	{
		printf("Initializing Source\n");
#ifdef DumpSourceLoad
		printf("Rebuilding as Dump could not be loaded correctly\n");
#endif

		QueryPerformanceCounter(&init_bnfpassed);

#ifdef DumpSource
		int oldMallocID, oldnTreeSize, oldMallocCount;

		oldMallocID = MallocID;
		oldnTreeSize = nTreeSizeMax;
		oldMallocCount = MallocLogCount;
#endif

		if (SourceInit() == 1) {return(1);}
		printf("Done\n");

#ifdef DumpSource
		int CompactSize;
		
		if (true)
		{
			printf("Rebuilding Compact Source...\n\t");

			CompactSize = PackMallocIDS(oldMallocID);
			int VirtualAllocError = 1;
			CompactSourceAllocated = (VirtualAlloc((void*) VirtualCompactBase, CompactSize, MEM_RESERVE, PAGE_READWRITE) != NULL);
			if (CompactSourceAllocated)
			{
				if (VirtualAlloc((void*) VirtualCompactBase, CompactSize, MEM_COMMIT, PAGE_READWRITE) == NULL)
				{
					VirtualFree((void*) VirtualCompactBase, NULL, MEM_RELEASE);
				}
				else
				{
					VirtualAllocError = 0;
				}
			}

			if (VirtualAllocError)
			{
				printf("Memmory Allocation Error\n");
				breakpoint("run_init");;
			}

			SourceExit();
			MallocID = oldMallocID;
			nTreeSizeMax = oldnTreeSize;
			bnf::pTree = 0;
			MallocLogCount = oldMallocCount;

			ReserveHigh = 1;
			if (SourceInit() == 1) {return(1);}
			ReserveHigh = 0;

			ReleaseMallocIDS();
			printf("Done\n");
		}
#endif

		QueryPerformanceCounter(&init_end);

		printf("Init tool %d usec\n\n", (int) ((init_end.QuadPart - init_start.QuadPart) * 1000000 / qwFreq));

#ifdef DumpSource
#ifndef gccruntime
		if (SaveAllocs(CompactSize, init_bnfpassed.QuadPart, init_end.QuadPart, "source.dnd", &Source, sizeof(clsSource), bnf::SymbolNames, SymbolNameSizeCopy, 0))
		{
			printf("Could not Dump Source into File\n");
		}
#else
		printf("Cannot Dump Using GCC Runtime!\n");
#endif
#endif
	}
	else
	{
		printf("No Source Rebuild required\n");
	}
	AgainDep = (unsigned int*) mallocl(Source.FeatSourceCount * sizeof(int), "SourceInit-AgainDep");

#ifdef malloclog
	printf("Memmory Allocs after Init: %d\n", MallocLogCount);
#endif

	return(0);
}

int run_worktype()
{
	int i, j, k, l;
	if (worktype == 2)
	{
		ListSpells();
		return(-1);
	}

	if (worktype == 1)
	{
		int* mprob;
		j = AdvancedRand(Source.MonsterTypeSourceCount, &FixedProb, 0, (char*) &Source.MonsterTypeSource[0].Name.buffer, sizeof(clsMonsterTypeSource), "Typ whlen!", 1, 1);
		mprob = (int*) mallocl(Source.MonsterSourceCount * sizeof(int), "run-mprob");
		for (i = 0;i < Source.MonsterSourceCount;i++)
		{
			if (Source.MonsterSource[i].Type == j)
			{
				mprob[i] = 1;
			}
			else
			{
				mprob[i] = 0;
			}
		}
		l = AdvancedRand(Source.MonsterSourceCount, mprob, sizeof(int), (char*) &Source.MonsterSource[0].Name.buffer, sizeof(clsMonster), "Monster whlen!", 1, 1);

		int a, b;
		for (k = 0;k < 11;k++)
		{
			printf("Template: %s\n", Source.TemplateSource[k].Name.buffer);
			for (j = 0;j < 4;j++)
			{
				a = DetermineCR(l, j, k, &b, 0);
				if (a <= 60)
				{
					printf("\tHD Inc: %2d - Possible CRs: %2d - %2d\n", j, a, b);
				}
			}
			printf("\n");
		}

		freel(mprob);

		while(kbhit()){getch();}
		getchar();
		getchar();
		return(-1);
	}
	return(0);
}

int run_templates()
{
	int i, j, k;

	CharCount = random(CreatureMin, CreatureMax, "Anzahl eingeben!", 0);
	FullCR = random(FullCRMin, FullCRMax, "HG Eingeben!", 0);

	SetNewIdent("run_templates-Characters");
	Characters = new clsChar[CharCount];
	SetNewIdent("run_templates-SR");
	SRs = new int[CharCount];
	SetNewIdent("run_templates-CT");
	CTs = new CharTemplate[CharCount];
	Screens = (HANDLE*) mallocl((CharCount + 1) * sizeof(HANDLE), "run-Screen");

	if (SRs == 0 || CTs == 0 || Screens == 0 || Characters == 0)
	{
		printf("Memmory Allocation Error\n");
		quitprog();
	}

	for (i = 0;i < CharCount;i++)
	{
		Characters[i].CreationTemplate = &CTs[i];
	}

	for (i = 0;i < CharCount;i++)
	{
		SRs[i] = FullCR;
		for (j = CharCount;j > 1;j /= 2)
		{
			SRs[i]--;
			if (SRs[i] > 5)
			{
				SRs[i]--;
			}
			if (SRs[i] > 10)
			{
				SRs[i]--;
			}
			SRs[i] = max(0, SRs[i]);
		}
	}

	i = 0;
	j = CharCount - 1;
	while (i < j)
	{
		k = random(0, FullCR / 5 + 1, "HG Abweichung bei Gegner", 0);
		if (random(0, 1, "Abweichung umkehren?", 0) == 1)
		{
			k *= -1;
		}
		if (SRs[i] + k < FullCR && SRs[j] - k > 0)
		{
			SRs[i] += k;
			SRs[j] -= k;
		}
		i++;
		j--;
	}

	for (i = 0;i < CharCount;i++)
	{
		CTs[i].AttributePreset = 0;
		if (ChooseClass && (!manual))
		{
			CTs[i].AttributeType = 1;
		}
		else
		{
			CTs[i].AttributeType = -1;
		}
		if (DrawType == -1)
		{
			CTs[i].AttributeType = 0;
		}
		CTs[i].Class = NULL;
		CTs[i].MinLevel = SRs[i];
		CTs[i].MaxLevel = SRs[i];
		CTs[i].Monster = min(1, CreatureType);
		CTs[i].MonsterName = -1;
		CTs[i].Mixed = (CreatureType == 2);
		CTs[i].Race = -1;
		CTs[i].DrawType = DrawType;
		CTs[i].Life = -100;
	}
	if (CharCount == 1)
	{
		CTs[0].MinLevel = FullCRMin;
		CTs[0].MaxLevel = FullCRMax;
	}

	return(0);
}

int run_reproduce_2()
{
	char VCheck[6];
	char fullrepfile[SmallBufferLen] = "Save\\";

	ZeroMemory(VCheck, 6);

	reproduce = 0;
	readreproduce = 1;
	*prepos = 0;

	strcat(fullrepfile, refname);
	str_replace('\\', '-', fullrepfile + 5);
	reRead = fopen(fullrepfile, "rb");
	if (reRead == 0)
	{
		printf("Fatal Error\nFile not found: %s\n", refname);
		return(1);
	}

	fread(Characters[0].CreationTemplate, sizeof(CharTemplate) - sizeof(CharTemplate::restru) - sizeof(CharTemplate::seedstru), 1, reRead);

	if (strncmp((const char*) Characters[0].CreationTemplate, "DNDV", 4) != 0)
	{
		printf("File is not a DND Reproduce File\nExiting\n");
		return(1);
	}

	if (Characters[0].CreationTemplate->TemplateType == 49)
	{
		UseIsaac = true;
		fread(&Characters[0].CreationTemplate->seed.seed[0], sizeof(CharTemplate::seedstru), 1, reRead);
	}
	else
	{
		UseIsaac = false;
	}

	DrawType = Characters[0].CreationTemplate->DrawType;
	CharCount = 1;

	return(0);
}

int run_screenbuffer()
{
	int i;
	COORD Size;

	CONSOLE_SCREEN_BUFFER_INFO Info;
	GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE), &Info);
	Size.X = (short) max((DWORD) Info.dwMaximumWindowSize.X, (DWORD) 125);
	Size.Y = (short) max((DWORD) Info.dwMaximumWindowSize.Y, (DWORD) 500);

	Screens[0] = GetStdHandle(STD_OUTPUT_HANDLE);
	
	for (i = 1;i <= CharCount;i++)
	{
		Screens[i] = CreateConsoleScreenBuffer(GENERIC_WRITE, 0, NULL, CONSOLE_TEXTMODE_BUFFER, NULL);
		SetConsoleScreenBufferSize(Screens[i], Size);
		ClearConsole(i);
		if (Screens[i] == INVALID_HANDLE_VALUE)
		{
			printf("Could not create screen buffer\n");
			quitprog(false);
		}
	}

	return(0);
}

int run_main()
{
	int i, j;
	int loopcount = 0;
	__int64 TotalTime = 1, TotalDisplayTime = 1;

	LARGE_INTEGER full_start, full_now;
	QueryPerformanceCounter(&full_start);

	for (i = 0;i < CharCount;i++)
	{
		SetConsoleActiveScreenBuffer(Screens[0]);
		CurChar = i + 1;
		do
		{
			CreateChar(&Characters[i]);
			if (loopdisplay)
			{

				TempTable = &FullTables[i][0];
				CurMoney = &Moneys[i];
				if (loop)
				{
					DisplayChar(&Characters[i]);
				}
				ClearConsole(CurChar);
			}

			if (readreproduce)
			{
				readreproduce = 0;
			}

			loopcount++;
			if (loop)
			{
				QueryPerformanceCounter(&full_now);
				full_now.QuadPart = (__int64) loopcount * qwFreq / (full_now.QuadPart - full_start.QuadPart);
				TotalTime += (__int64) Characters[i].CreationTime;
				TotalDisplayTime += (__int64) Characters[i].DisplayTime;
				printf("%d Loop (%d/%3d usec, %d / sec    -    AVG: %d/%3d usec, %d / sec (%d))\n",
					loopcount,
					Characters[i].CreationTime,
					Characters[i].DisplayTime, 1000000 / Characters[i].CreationTime,
					(int) (TotalTime / (__int64) loopcount),
					(int) (TotalDisplayTime / (__int64) loopcount),
					(int) (1000000 / (TotalTime / (__int64) loopcount)),
					full_now.LowPart);
			}
			if (loop && kbhit())
			{
				j = getch();
				if (j == 'l')
				{
					ClearConsole(0);
					loop = 0;
				}
				else if (j == 'r')
				{
					TotalTime = 1;
					TotalDisplayTime = 1;
					QueryPerformanceCounter(&full_start);
					loopcount = 0;
				}
			}
			SleepEx(0, false);
		}
		while (loop);
		loopdisplay = 0;

		SetConsoleActiveScreenBuffer(Screens[i + 1]);
		TempTable = &FullTables[i][0];
		CurMoney = &Moneys[i];

		DisplayChar(&Characters[i]);
	}

	j = min(1, CharCount);
	if (CharCount > 1)
	{
		SetConsoleActiveScreenBuffer(Screens[0]);
		j = 0;
	}
	DoTable();

	return(j);
}

void run_msgloop(int j)
{
	int i, k;

	do
	{
		i = getch();

		if (i == 6 * 16 + 1 || i == 4 * 16 + 1)
		{
			j = max(0, j - 1);
		}
	
		if (i == 6 * 16 + 4 || i == 4 * 16 + 4)
		{
			j = min(CharCount, j + 1);
		}

		if (i == 7 * 16 + 7 || i == 5 * 16 + 7)
		{
			j = CharCount;
		}

		if (i == 7 * 16 + 3 || i == 5 * 16 + 3)
		{
			j = 0;
		}

		if (i >= 48 && i < 58 && i <= 48 + CharCount)
		{
			j = i - 48;
		}

		if (i == 82 || i == 114)
		{
			if (CharCount)
			{
				if (j == 0)
				{
					ClearConsole(0);
					for (k = 0;k < CharCount;k++)
					{
						ClearConsole(k + 1);
						CurChar = k + 1;
						SetConsoleActiveScreenBuffer(Screens[0]);
						CreateChar(&Characters[k]);
						SetConsoleActiveScreenBuffer(Screens[k + 1]);
						TempTable = &FullTables[k][0];
						CurMoney = &Moneys[k];
						DisplayChar(&Characters[k]);
					}
					SetConsoleActiveScreenBuffer(Screens[0]);
				}
				else
				{
					ClearConsole(0);
					SetConsoleActiveScreenBuffer(Screens[0]);
					ClearConsole(j);
					CurChar = j;
					CreateChar(&Characters[j - 1]);
					TempTable = &FullTables[j - 1][0];
					CurMoney = &Moneys[j - 1];
					DisplayChar(&Characters[j - 1]);
					SetConsoleActiveScreenBuffer(Screens[j]);
				}
				DoTable();
			}
		}

		if (i == '+' || i == '-' || i == '*')
		{
			if (j != 0)
			{
				int OldLife;
				OldLife = Characters[j - 1].Life;
				ClearConsole(0);
				CurChar = j;
				ClearConsole(j);
				TempTable = &FullTables[j - 1][0];
				CurMoney = &Moneys[j - 1];
				ChangeChar(&Characters[j - 1], i);
				DisplayChar(&Characters[j - 1]);
				DoTable();
				TPLeft[j] += Characters[j - 1].Life - OldLife;
				DoConsoleTP(j);
			}
		}

		if (i == 'v' && j != 0)
		{
			char savename[257];
			int i2;

			ClearConsole(0);
			SetConsoleActiveScreenBuffer(Screens[0]);
			
			printf("Dateinamen zum speichern angeben! ");

			while (kbhit())
			{
				getch();
			}

			savename[0] = 0;
			while (savename[0] == 0 || savename[0] == 13 || savename[0] == 10)
			{
				fgets(savename, 256, stdin);
			}

			for (i2 = 0;i2 < (signed) strlen(savename);i2++)
			{
				if (savename[i2] == 10 || savename[i2] == 13)
				{
					savename[i2] = 0;
					break;
				}
			}

			prepos = (unsigned int*) &Characters[j - 1].CreationTemplate->re.repos;
			retemp = (unsigned int*) &Characters[j - 1].CreationTemplate->re.retemp[0];
			CopyMemory((void*) &reheader, (void*) Characters[j - 1].CreationTemplate, sizeof(CharTemplate));

			saverep(savename, true);

			SetConsoleActiveScreenBuffer(Screens[j]);
		}

		if ((i == 84 || i == 116) && j != 0)
		{
			ChangeTP(j);
			DoConsoleTP(j);
		}

		if ((i | 32) == ('n' | 32))
		{
			Restart = true;
			i = 'q';
			j = 0;
			ClearConsole(0);
		}
		SetConsoleActiveScreenBuffer(Screens[j]);
	} while (i != 7 * 16 + 1 && i != 5 * 16 + 1);
}

void run_cleanup(int cleanup_screans = 1)
{
	int i;
	if (cleanup_screans)
	{
		SetConsoleActiveScreenBuffer(Screens[0]);
		ClearConsole(0);
		for (i = 1;i <= CharCount;i++)
		{
			CloseHandle(Screens[i]);
		}
	}

	delete[] Characters;
	delete[] CTs;
	delete[] SRs;
	freel(Screens);

	CDummy.~clsChar();
	DoEffects2(NULL, 0, 2);
	freel(AgainDep);
}

int run()
{
	int i, retVal;
	LARGE_INTEGER randinit;

	if (ThrowTestExeption)
	{
		breakpoint("dndmain (Test)");
	}

	prepos = (unsigned int*) &CTtmp.re.repos;
	retemp = (unsigned int*) &CTtmp.re.retemp[0];
	*prepos = 0;

	QueryPerformanceCounter(&randinit);
	i = randinit.LowPart;
	srand(i);

	manual2 = manual;

	retVal = run_init();
	if (retVal)
	{
		return((retVal + 1) / 2);
	}

	retVal = run_worktype();
	if (retVal == -1)
	{
		return(0);
	}
	else if (retVal)
	{
		return(1);
	}

	if (run_templates())
	{
		return(1);
	}

	if (reproduce == 2)
	{
		if (run_reproduce_2())
		{
			run_cleanup(0);
			return(1);
		}
	}

	if (run_screenbuffer())
	{
		run_cleanup(0);
		return(1);
	}

	InitPassed = 1;

	IsaacInitDone = false;

	retVal = run_main();

	run_msgloop(retVal);

	run_cleanup();

	return(0);
}